package dyn_graph;

import graph.Attributes;
import java.util.Map;
import java.util.NavigableSet;
import java.util.SortedSet;
import java.util.TreeMap;

public class DynVert
{

	
	///////////////
	// CONSTANTS //
	///////////////

	
	
	////////////
	// FIELDS //
	////////////
	
	final String id;
	final TreeMap<String, Attributes> attrsSeq;
	
	
	
	

	//////////////////
	// CONSTRUCTORS //
	//////////////////
	
	/**
	 * 
	 * @param vertId
	 * @param dynAttrs
	 */
	public DynVert(String vertId)
	{
		this.id = vertId;
		this.attrsSeq = new TreeMap<String, Attributes>();
	}
	
	

	/////////////////////////
	// GETTERS AND SETTERS //
	/////////////////////////

	/**
	 * 
	 * @return
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * 
	 * @return
	 */
	public SortedSet<String> getSeqIds()
	{
		return attrsSeq.navigableKeySet();
	}
	
	/**
	 * 
	 * @return
	 */
	public int getFreq()
	{
		return attrsSeq.size();
	}
	
	/**
	 * 
	 * @param seqId
	 * @return
	 */
	public Attributes getAttrs(String seqId)
	{
		return attrsSeq.get(seqId);
	}
	
	/**
	 * 
	 * @param seqId
	 * @param attrId
	 * @return
	 */
	public String getAttrVal(String seqId, String attrId)
	{
		Attributes attrs = attrsSeq.get(seqId);
		if(attrs != null)
		{
			return attrs.getValue(attrId);
		}
		return null;
	}
	
	
	
	
	////////////////////
	// PUBLIC METHODS //
	////////////////////

	/////////////////////
	// PRIVATE METHODS //
	/////////////////////

	//////////////////////
	// STANDARD METHODS //
	//////////////////////

}
