package graph;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;



/**
 * 
 *
 */
public class Attributes
{
	
	////////////
	// FIELDS //
	////////////
	
	private Map<String,String> attrs;

	
	
	
	//////////////////
	// CONSTRUCTORS //
	//////////////////

	/**
	 * 
	 */
	public Attributes()
	{
		attrs = new HashMap<String,String>();
	}
	
	
	
	
	
	/////////////////////////
	// GETTERS AND SETTERS //
	/////////////////////////

	/**
	 * 
	 * @param attrId
	 * @return
	 */
	public String getValue(String attrId)
	{
		return attrs.get(attrId);
	}

	/**
	 * 
	 * @return
	 */
	public Set<String> getIds()
	{
		return attrs.keySet();
	}

	/**
	 * 
	 * @param attrId
	 * @param attrVal
	 * @return
	 */
	public String set(String attrId, String attrVal)
	{
		return attrs.put(attrId, attrVal);
	}
	
	/**
	 * 
	 * @param newAttrs
	 */
	public void set(Attributes attrs)
	{
		this.attrs.putAll(attrs.attrs);
	}
	
	
	
	
	
	////////////////////
	// PUBLIC METHODS //
	////////////////////

	/**
	 * 
	 * @param attrId
	 */
	public String remove(String attrId)
	{
		return attrs.remove(attrId);
	}

	/**
	 * 
	 * @param attrId
	 * @return
	 */
	public boolean containsId(String attrId)
	{
		return attrs.containsKey(attrId);
	}
	
	
	
	
	
	//////////////////////
	// STANDARD METHODS //
	//////////////////////
	
	/*
	 * (non-Javadoc)
	 * @see java.util.AbstractMap#toString()
	 */
	@Override
	public String toString()
	{
		StringBuffer sb = new StringBuffer();
		sb.append("[");
		for(String attrId : attrs.keySet())
		{
			String attrVal = attrs.get(attrId);
			sb.append(attrId + "=" + attrVal + ", ");
		}
		//TODO: Get rid of last ", " 
//		sb.deleteCharAt(sb.length()-1);
		sb.append("]");
		return sb.toString();
	}
	
	
	
	
	
}
