package graph;




public abstract class GraphElem
{

	////////////
	// FIELDS //
	////////////
	
	final String id;
	final Attributes attrs;
	final GraphElemType get;
	
	
	
	
	
	
	//////////////////
	// CONSTRUCTORS //
	//////////////////
	
	
	/**
	 * 
	 * @param id
	 * @param get
	 */
	GraphElem(String id, GraphElemType get)
	{
		this.id = id;
		this.attrs = new Attributes();
		this.get = get;
	}
	
	/**
	 * 
	 * @param id
	 * @param typeStr
	 */
	GraphElem(String id, String typeStr)
	{
		this(id, GraphElemType.parseType(typeStr));
	}
	
	
	

	
	
	

	/////////////////////////
	// GETTERS AND SETTERS //
	/////////////////////////
	
	/**
	 * 
	 * @return
	 */
	public String getId()
	{
		return id;
	}
	
	/**
	 * 
	 * @return
	 */
	public Attributes getAttrs()
	{
		return attrs;
	}
	
	/**
	 * Gets the value associated with the specified attribute ID.
	 * @param attrId The ID of the attribute to get.
	 * @return The value associated with the specified attribute ID
	 * 		   or null if no such ID exists.
	 */
	public String getAttrVal(String attrId)
	{
		return attrs.getValue(attrId);
	}
	
	/**
	 * 
	 * @param attrId
	 * @param attrVal
	 * @return
	 */
	public String setAttr(String attrId, String attrVal)
	{
		return attrs.set(attrId, attrVal);
	}
	
	/**
	 * 
	 * @param attrs
	 */
	public void setAttrs(Attributes attrs)
	{
		for(String attrId : attrs.getIds())
		{
			String attrVal = attrs.getValue(attrId);
			this.setAttr(attrId, attrVal);
		}
	}

	

}
