package graph;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;



/**
 * 
 */
public class Vertices implements Iterable<Vertex>
{

	////////////
	// FIELDS //
	////////////
	
	private final Map<String,Vertex> vertMap;

	
	
	
	
	//////////////////
	// CONSTRUCTORS //
	//////////////////

	/**
	 * 
	 */
	public Vertices()
	{
		this.vertMap = new HashMap<String,Vertex>();
	}
	
	
	
	
	
	
	/////////////////////////
	// GETTERS AND SETTERS //
	/////////////////////////

	/**
	 * 
	 * @param vert
	 */
	public Vertex getVertex(String vertId)
	{
		return vertMap.get(vertId);
	}
	
	
	
	
	
	////////////////////
	// PUBLIC METHODS //
	////////////////////

	/**
	 * 
	 * @param vertex
	 * @return
	 */
	public boolean add(Vertex vertex)
	{
		if(vertMap.containsKey(vertex.getId()))
			return false;
		vertMap.put(vertex.getId(), vertex);
		return true;
	}
	
	/**
	 * 
	 * @param vertId
	 */
	public Vertex remove(String vertId)
	{
		return vertMap.remove(vertId);
	}
	
	/**
	 * 
	 * @param vertId
	 * @return
	 */
	public boolean containsId(String vertId)
	{
		return vertMap.containsKey(vertId);
	}
	
	/**
	 * 
	 * @param vertex
	 * @return
	 */
	public boolean contains(Vertex vertex)
	{
		if(vertex == null) return false;
		String vertId = vertex.getId();
		if(!this.containsId(vertId))
			return false;
		Vertex refVert = vertMap.get(vertId);
		return(vertex.equals(refVert));
	}

	/**
	 * 
	 * @return
	 */
	public int size()
	{
		return vertMap.size();
	}
	
	/**
	 * 
	 * @param atf
	 */
	public void setAttrs(Atf atf)
	{
		for(String vertId : atf.getElemIds())
		{
			Vertex vertex = vertMap.get(vertId);
			if(vertex != null)
				vertex.setAttrs(atf.getAttrs(vertId));
		}
	}
	
	/**
	 * 
	 */
	public Iterator<Vertex> iterator()
	{
		return vertMap.values().iterator();
	}
	
	
	
	
	
	
	/////////////////////
	// PRIVATE METHODS //
	/////////////////////

	
	
	
	
	//////////////////////
	// STANDARD METHODS //
	//////////////////////
	

}
