package testing;

import graph.GraphFile;
import graph.GraphSequence;
import graphview.Mwadj;
import graphview.Wadj;
import java.io.File;
import java.io.IOException;
import java.util.zip.DataFormatException;


/**
 * 
 */
public class MwadjTest
{
	private static final String WADJ_PATH = "input/wadj_files";
	private static final String IN_PATH = "input/test.mwadj";
	private static final String OUT_PATH = "output/test.mwadj";
	
	
	/**
	 * 
	 * @param args
	 * @throws IOException
	 * @throws DataFormatException
	 * @throws InterruptedException 
	 */
	public static void main(String[] args) throws IOException, DataFormatException
	{
		testReadFromFile();
	}
	
	
	
	private static void testReadFromFile() throws IOException, DataFormatException
	{
		Mwadj mwadj = new Mwadj(new File(IN_PATH));
		mwadj.writeToFile(new File(OUT_PATH));
	}
	
	
	
	private static void testWriteToFile() throws IOException, DataFormatException
	{

		GraphSequence graphSeq = new GraphSequence();
		File dir = new File(WADJ_PATH);
		for(String fileName : dir.list())
		{
			File wadjFile = new File(WADJ_PATH + "/" + fileName);
			GraphFile wadj = new Wadj(wadjFile);
			String seqNum = fileName.replaceAll(".wadj", "");
			graphSeq.addGraph(wadj.getGraph(), seqNum);
		}
		Mwadj mwadj = new Mwadj(graphSeq);
		mwadj.writeToFile(new File("output/manifest.mwadj"));
	}

}


