package testing;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.Set;
import java.util.zip.DataFormatException;

import utils.ColorMapper;


import gephi.Rec;
import graph.Atf;
import graph.Attributes;
import graph.Edge;
import graph.Edges;
import graph.Graph;
import graph.GraphFile;
import graph.GraphSequence;
import graph.Vertex;
import graphview.Wadj;



public class Recency {
	
	public static void main(String[] args) throws IOException	{
		
		GraphSequence graphSeq = new GraphSequence();
		
		// stores frequency of all edges at each day Map<String, Double> represents a mapping of EdgeId to Freq.
		List<Map<String, Double>> allfreq = new ArrayList<Map<String, Double>>();
		
		// create an Attributes obj for each day
		List<Attributes> attrsMaps = new ArrayList<Attributes>();
		
		for(int i = 1 ; i <= 30 ; i++)
		{
			attrsMaps.add(new Attributes());
		}
		

		// construct 30 graphs from 30 .wadj files and store in GraphSequence data structure
		for(int i = 1 ; i <= 30 ; i++)
		{ 
			GraphFile wadj;
			
			try 
			{
				wadj = new Wadj(new File("backup/Timestamp_"+ i + "/MST_" + i + ".wadj")); 
			}
			catch (DataFormatException e)
			{
				System.out.println("Incorrect Data type: Terminating Program");
				return;
			}
			
			Integer seqId = i;
			graphSeq.addGraph(wadj.getGraph(), seqId.toString());
			
			Map<String, Double> freq = graphSeq.getEdgeFreqs();
			allfreq.add(freq);
			
			System.out.println(i);
		}
		
		
		// check allfreq
		for(int i = 1 ; i <= 30 ; i++)
		{
			Set<String> Edgeid = allfreq.get(i-1).keySet();
			for(String s : Edgeid)
			{
				System.out.println(s+":"+allfreq.get(i-1).get(s));
			}
		}
		
		
//		// checking VertexIds()
//		Set<String> vid = graphSeq.getVertexIds();
//		for(String s : vid)
//		{
//			System.out.println("Vertex: "+s);
//		}
		
		
//		// checking VertexIds()
//		Set<String> eid = graphSeq.getEdgeIds();
//		for(String s : eid)
//		{
//			if(graphSeq.getGraph(1).containsEdge(s))
//				System.out.println("Edge: "+s);
//		}
		
	}
}

