package testing;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.nio.channels.FileChannel;

public class RenameWadjs
{
	private static final String FILE_NAME = "content2portPairs_pieceCount.wadj";
	private static final String FILE_EXT = ".wadj";
	private static final String DIR_PATH = "input/wadj_files";
	
	
	public static void main(String args[]) throws IOException
	{
		File dir = new File(DIR_PATH);
		for(String seqNum : dir.list())
		{
			File wadj = new File(DIR_PATH + "/" + seqNum, FILE_NAME);
			copyFile(wadj, new File(DIR_PATH, seqNum + FILE_EXT));
		}
	}
	
	/**
	 * 
	 * @param sourceFile
	 * @param destFile
	 * @throws IOException
	 */
	public static void copyFile(File sourceFile, File destFile) throws IOException 
	{
	    if(!destFile.exists()) 
	        destFile.createNewFile();
	    
	    FileChannel source = null;
	    FileChannel destination = null;
	    try 
	    {
	        source = new FileInputStream(sourceFile).getChannel();
	        destination = new FileOutputStream(destFile).getChannel();
	        destination.transferFrom(source, 0, source.size());
	    }
	    finally 
	    {
	        if(source != null) 
	            source.close();
	        if(destination != null) 
	            destination.close();
	    }
	}

}
