package testing;

import java.awt.Color;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.channels.FileChannel;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import utils.ColorMapper;


import gephi.Rec;
import graph.Atf;
import graph.Attributes;
import graph.Edge;
import graph.Edges;
import graph.Graph;
import graph.GraphFile;
import graph.GraphSequence;
import graph.Vertex;
import graphview.Wadj;




public class Test 
{

	
	
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException 
	{
		
//		Map<Integer,String> Code2Label = new HashMap<Integer,String>();
//		
//		Labels labels = new Labels(new File("input/misc/content2portPairs_pieceCount.mwadj.labels"));
//		Map<Integer,Map<String,String>> labelsMap = labels.getLabelsMap();
//		for(Integer vertexId : labelsMap.keySet())
//		{
//			Map<String,String> tags = labelsMap.get(vertexId);
//			String labelValue = tags.get("label");
//			String[] tokens = labelValue.split(" ");
//			
//			if(tokens.length > 1)
//			{
//				String portpair = tokens[0] + "->" + tokens[1] ;
//				Code2Label.put(vertexId, portpair);
//			}
//			else
//				Code2Label.put(vertexId, tokens[0]);
//		}
//		
//		for(Integer code : Code2Label.keySet())
//		{
//			String label = Code2Label.get(code);
//			System.out.println(code + " " + label + "\n");
//		}
		
		
//		File vertAttrFile = new File("input/vert.attrs");
//		AttributesMap vertAttrsMap = new AttributesMap(vertAttrFile);
//
//		for(int i = 1; i <= 30; i++)
//		{
//			System.out.println(i);
//			
//			GraphFile wadj = new Wadj(new File("input/Timestamp_" + i + "/MST_" + i + ".wadj"));
//			Graph graph = wadj.getGraph();
//			
//			File edgeAttrFile = new File("input/Timestamp_" + i + "/edge.attrs");
//			AttributesMap edgeAttrsMap = new AttributesMap(edgeAttrFile);
//			
//			Edges edges = graph.getEdges();
//			edges.addAttrs(edgeAttrsMap);
//			
//			Vertices verts = graph.getVertices();
//			verts.addAttrs(vertAttrsMap);
//			
//			Rec rec = new Rec();
//			rec.nextGraph(graph);
//			rec.writeToFile(new File("input/Timestamp_" + i + "/events.rec"));
//			rec.writeToFile(new File("input/Timestamp_" + i + "/events.rec"));
//			rec.writeToFile(new File("input/events/events_" + i + ".rec"));
//		}
		
		
	}
	
	public static void copyFile(File sourceFile, File destFile) throws IOException 
	{
	    if(!destFile.exists()) 
	        destFile.createNewFile();

	    FileChannel source = null;
	    FileChannel destination = null;

	    try {
	        source = new FileInputStream(sourceFile).getChannel();
	        destination = new FileOutputStream(destFile).getChannel();
	        destination.transferFrom(source, 0, source.size());
	    }
	    finally 
	    {
	        if(source != null)
	            source.close();
	        if(destination != null)
	            destination.close();
	    }
	}
	
	private static void removeLines(File file, int i) throws IOException
	{
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("input/Timestamp_" + i + "/edge.attrs")));
		
		BufferedReader reader = new BufferedReader(new FileReader(file));
		String line;
		while((line = reader.readLine()) != null)
		{
			if(!line.contains("\"freq\"=\"0.0\""))	
			{
				writer.write(line);
				writer.newLine();
				writer.flush();
			}
				
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	private static void readVertexIds(File inputFile, List<Integer> vertexIds) throws IOException
	{
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		String line;
		while((line = reader.readLine()) != null)
		{
			vertexIds.add(Integer.parseInt(line.trim()));			
		}
	}
	
	
	
	
	

	
	
	public static void writeToFile(File outputFile, List<Integer> ids) throws IOException
	{
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		for(Integer id : ids)
		{
			writer.write(id.toString());
			writer.newLine();
			writer.flush();
		}
	}

	/**
	 * 
	 * @param vertexMapFile
	 * @throws IOException 
	 */
	private static void readVertexMap(File vertexMapFile, Map<Integer,Integer> vertexMap) throws IOException
	{
		BufferedReader reader = new BufferedReader(new FileReader(vertexMapFile));
		String line;
		while((line = reader.readLine()) != null)
		{
			Scanner scanner = new Scanner(line);
			scanner.useDelimiter(",");
			Integer vert1Id = scanner.nextInt();
			Integer vert2Id = scanner.nextInt();
			vertexMap.put(vert2Id, vert1Id);			
		}
	}
	
	
	
}



//int min = -500;
//int max = 500;
//ColorMapper colorMapper = new ColorMapper();
//for(int i = min; i <= max; i++)
//{
//	Color color = colorMapper.getColor(min, max, i);
//	System.out.printf("%d: %d %d %d%n", i, color.getRed(), color.getGreen(), color.getBlue());
//}



//List<Integer> portPairIds = new ArrayList<Integer>();
//List<Integer> mappedPortIds = new ArrayList<Integer>();
//List<Integer> contentIds = new ArrayList<Integer>();
//List<Integer> mappedContentIds = new ArrayList<Integer>();
//
//Labels labels = new Labels(new File("input/content2portPairs_pieceCount.mwadj.labels"));
//Map<Integer,Map<String,String>> labelsMap = labels.getLabelsMap();
//for(Integer vertexId : labelsMap.keySet())
//{
//	Map<String,String> tags = labelsMap.get(vertexId);
//	String labelValue = tags.get("label");
//	String[] tokens = labelValue.split(" ");
//	if(tokens.length > 1)
//		portPairIds.add(vertexId);
//	else
//		contentIds.add(vertexId);
//}
//
//
//File vertexMapFile = new File("input/vertexMap.txt");
//Map<Integer,Integer>vertexMap = new TreeMap<Integer,Integer>();
//readVertexMap(vertexMapFile, vertexMap);
//
//for(Integer oldId : portPairIds)
//{
//	mappedPortIds.add(vertexMap.get(oldId));
//}
//File portsFile = new File("output/PortPairIds_mapped.txt");
//writeToFile(portsFile, mappedPortIds);
//
//for(Integer oldId : contentIds)
//{
//	mappedContentIds.add(vertexMap.get(oldId));
//}
//File contsFile = new File("output/ContentIds_mapped.txt");
//writeToFile(contsFile, mappedContentIds);



//for(int i = 1 ; i <= 30; i++)
//{
//	GraphFile wadj = new Wadj(new File("input/MST_" + i + ".wadj")); 
//	Graph graph = wadj.getGraph();
//	
//	XYCoords coords = new XYCoords(new File("input/XY.coords"));
//	graph.addCoords(coords);
//
//	String outputDotFile = "output/MST_" + i + ".dot";
//	writeDotFile(graph, outputDotFile);
	
//	List<Graph> graphs = new ArrayList<Graph>();
//	graphs.add(graph);
//	
//	Rec rec = new Rec(graphs);
//	rec.writeToFile(new File("output/events_MST_" + i + ".rec"));
//}

//List<Integer> portPairIds = new ArrayList<Integer>();
//List<Integer> contentsIds = new ArrayList<Integer>();
//File portPairFile = new File("input/PortPairIds_mapped.txt");
//File contentsFile = new File("input/ContentIds_mapped.txt");
//
//readVertexIds(portPairFile, portPairIds);
//readVertexIds(contentsFile, contentsIds);
//
//BufferedWriter writer = new BufferedWriter(new FileWriter("output/type.attrs"));
//for(Integer portPairId : portPairIds)
//{
//	writer.write(portPairId + " \"type\"=\"portpair\"\n");
//	writer.flush();
//}
//for(Integer contentsId : contentsIds)
//{
//	writer.write(contentsId + " \"type\"=\"contents\"\n");
//	writer.flush();
//}

//if(attrs.get("type").equals("portpair"))
//{
//	attrs.put("r", "0");
//	attrs.put("g", "1");
//	attrs.put("b", "0");
//}
//else
//{
//	attrs.put("r", "0.392");
//	attrs.put("g", "0.584");
//	attrs.put("b", "0.93");
//}





//GraphSequence graphSeq = new GraphSequence();
//for(int i = 1 ; i <= 30; i++)
//{
//	GraphFile wadj = new Wadj(new File("input/MST_" + i + ".wadj")); 
//	graphSeq.add(wadj.getGraph());
	
//	XYCoords coords = new XYCoords(new File("input/XY.coords"));
//	graph.addCoords(coords);
//
//	String outputDotFile = "output/MST_" + i + ".dot";
//	writeDotFile(graph, outputDotFile);
	
//	List<Graph> graphs = new ArrayList<Graph>();
//	graphs.add(graph);
//	
//	Rec rec = new Rec(graphs);
//	rec.writeToFile(new File("output/events_MST_" + i + ".rec"));
//}

//List<AttributesMap> attrsMaps = new ArrayList<AttributesMap>();
//for(int i = 1; i <= 30; i++)
//{
//	attrsMaps.add(new AttributesMap());
//}
//Edges allEdges = graphSeq.getAllEdges();
//Map<Edge,List<Double>> edgeFreqs = graphSeq.getEdgeFreqs();
//for(int i = 1; i <= 30; i++)
//{
//	AttributesMap attrsMap = attrsMaps.get(i-1);
//	for(Edge edge : allEdges)
//	{
//		List<Double> freqs = edgeFreqs.get(edge);
//		attrsMap.addAttr(edge.getId(), "freq", freqs.get(i-1).toString());
//	}
//	attrsMap.writeToFile(new File("output/freq/edgeFreq_" + i + ".attrs"));
//}

//for(Edge edge : edgeFreqs.keySet())
//{
//	List<Double> freqs = edgeFreqs.get(edge);
//	System.out.print(edge + " ");
//	for(Double freq : freqs)
//	{
//		System.out.print(freq + " ");
//	}
//	System.out.println();
//}













//File file = new File("output/freq/edgeFreq_" + i + ".attrs");
//File copy = new File("backup/Timestamp_" + i + "/edge.attrs");
//copyFile(file, copy);
//for(int i = 1; i <= 30; i++)
//{
//	File in = new File("backup/Timestamp_" + i + "/edge.attrs");
//	removeLines(in, i);
//}


//ColorMapper cm = new ColorMapper();
//for(int i = 1; i <= 30; i++)
//{
//	System.out.println(i);
//	
//	GraphFile wadj = new Wadj(new File("input/Timestamp_" + i + "/MST_" + i + ".wadj"));
//	Graph graph = wadj.getGraph();
//	
//	File edgeAttrFile = new File("input/Timestamp_" + i + "/edge.attrs");
//	AttributesMap edgeAttrsMap = new AttributesMap(edgeAttrFile);
//	
//	Edges edges = graph.getEdges();
//	edges.addAttrs(edgeAttrsMap);
//	
//	
//	for(Edge edge : edges)
//	{
//		double freq = Double.parseDouble(edge.getAttrs().get("freq"));
//		Color color = cm.getColor(0, 1, freq);
//		edgeAttrsMap.addAttr(edge.getId(), "r", Integer.toString(color.getRed()));
//		edgeAttrsMap.addAttr(edge.getId(), "g", Integer.toString(color.getGreen()));
//		edgeAttrsMap.addAttr(edge.getId(), "b", Integer.toString(color.getBlue()));
//	}
//	edgeAttrsMap.writeToFile(new File("input/Timestamp_" + i + "/edge.attrs"));
//}